# Copyright 1999-2004 Gentoo Technologies, Inc.
# Distributed under the terms of the GNU General Public License v2
# $Header: /home/cvsroot/gentoo-x86/sys-devel/hardened-gcc/hardened-gcc-2.4.5.ebuild,v 1.3 2004/02/08 16:37:49 pappy Exp $
IUSE=""
S="${WORKDIR}/${P}"
DESCRIPTION="This package provides transparent PaX/etdyn ASLR and propolice/SSP in the gcc specs file."

HGCC_PKG_NAME="${P}.tar.gz"
HGCC_PKG_PATH="~pappy/gentoo-x86/sys-devel/hardened-gcc"

SRC_URI="mirror://${HGCC_PKG_NAME}
		http://dev.gentoo.org/${HGCC_PKG_PATH}/${HGCC_PKG_NAME}
		http://linbsd.net/${HGCC_PKG_PATH}/${HGCC_PKG_NAME}
		"

# these vars are used for TARGET installing in src_install
HGCC_ETDYN_BUILDING_OBJCT_PATH="/usr"
HGCC_SHSCRIPT_INSTALLATIONPATH="/usr/bin"
HGCC_CONFIG_INSTALLATIONPATH="/etc"
HGCC_COMMONSFILE_INSTALLATIONPATH="/usr/bin"

# these vars are used to find the SOURCE that is going to be installed to TARGET in src_install
HGCC_PKG_TGZ_PATH_CSU="${S}/gentoo/distrib/${PV}/${ARCH}/csu"
HGCC_PKG_TGZ_PATH_NONCSU="${S}/gentoo/distrib/${PV}/${ARCH}/noncsu"
HGCC_PKG_TGZ_PATH_CONFIG="${S}/gentoo/distrib/${PV}/config/hcc.conf"
HGCC_PKG_TGZ_PATH_NOARCH="${S}/gentoo/distrib/${PV}/noarch/hardened-gcc-common.sh"
HGCC_PKG_TGZ_PATH_ARCH="${S}/gentoo/distrib/${PV}/${ARCH}/hardened-gcc-arch-specific.sh"

HOMEPAGE="http://www.gentoo.org/proj/en/hardened/etdyn-ssp.xml"

KEYWORDS="x86" # 2.4.5 is the stable ebuild for x86, 2.4.6 will be the unstable test version for x86 and sparc

SLOT="0"
LICENSE="GPL-2"

DEPEND="x86? ( >=sys-devel/gcc-3.2.3 >=sys-libs/glibc-2.3.2 )"

src_unpack() {
	cd ${WORKDIR}; unpack ${HGCC_PKG_NAME}
}

src_compile() {
	[ -f ${S}/gentoo/install/hardened-gcc-${PV}.install ] || \
		die "no installer found: ${S}/gentoo/install/hardened-gcc-${PV}.install"

	${S}/gentoo/install/hardened-gcc-${PV}.install ${ARCH} ${PV} ${S}
}

src_install() {
	einfo "installing etdyn build dependencies in ${HGCC_ETDYN_BUILDING_OBJCT_PATH}"
	dodir ${HGCC_ETDYN_BUILDING_OBJCT_PATH}; into ${HGCC_ETDYN_BUILDING_OBJCT_PATH}

	dolib ${HGCC_PKG_TGZ_PATH_NONCSU}/crt1S_noncsu.o
	dolib ${HGCC_PKG_TGZ_PATH_NONCSU}/interp.o

	einfo "installing configuration file"
	dodir ${HGCC_CONFIG_INSTALLATIONPATH}; insinto ${HGCC_CONFIG_INSTALLATIONPATH}

	doins ${HGCC_PKG_TGZ_PATH_CONFIG}

	einfo "installing hcc scripts"
	dodir ${HGCC_SHSCRIPT_INSTALLATIONPATH}; exeinto ${HGCC_SHSCRIPT_INSTALLATIONPATH}

	doexe ${HGCC_PKG_TGZ_PATH_NOARCH}

	doexe ${HGCC_PKG_TGZ_PATH_ARCH}
	dosym "${HGCC_SHSCRIPT_INSTALLATIONPATH}/hardened-gcc-arch-specific.sh" "${HGCC_SHSCRIPT_INSTALLATIONPATH}/hcc"
	dosym "${HGCC_SHSCRIPT_INSTALLATIONPATH}/hardened-gcc-arch-specific.sh" "${HGCC_SHSCRIPT_INSTALLATIONPATH}/hardened-gcc"

	einfo "installing manpage"
	doman ${S}/gentoo/distrib/${PV}/man/hardened-gcc.8
}

pkg_postinst() {
	[ -e "${HGCC_SHSCRIPT_INSTALLATIONPATH}/hardened-gcc" ] && ${HGCC_SHSCRIPT_INSTALLATIONPATH}/hardened-gcc -A
}

## backup/restore logic
pkg_postrm() {
	[ ! -f "${HGCC_SHSCRIPT_INSTALLATIONPATH}/hardened-gcc" ] && gcc -dumpspecs > $(dirname $(gcc --print-libgcc-file-name))
}

